
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring控制反转与依赖注入(IOC、DI) / 憋错料</title>

    <meta name="description" content="Spring控制反转与依赖注入(IOC、DI) IOC: 反转控制   Inverse Of Control DI:依赖注入 Dependency Injection 目的:完成程序的解耦合 解释:在应用系统的开发过程中,有spring负责对象的创建,对象依赖关系的组装,对象属性的初始化,程序员只需要在程序接收spring创建的对象即可. Object obj= new Object(); IOC :  Object obj;  等着接收spring容器创建好的对象,在程序中将对象的创建的权限交出,反转到spring容器中. DI:  某个对">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Spring控制反转与依赖注入(IOC、DI)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>IOC: 反转控制 &nbsp; Inverse Of Control</p>
<p>DI:依赖注入 Dependency Injection</p>
<p>目的：完成程序的解耦合</p>
<p>解释：在应用系统的开发过程中，有spring负责对象的创建，对象依赖关系的组装，对象属性的初始化，程序员只需要在程序接收spring创建的对象即可。</p>
<p>Object obj= new Object();</p>
<p>IOC :&nbsp; Object obj;&nbsp; 等着接收spring容器创建好的对象，在程序中将对象的创建的权限交出，反转到spring容器中。</p>
<p>DI:&nbsp; 某个对象需要依赖的其他对象，由spring容器完成所需要依赖对象的赋值</p>
<h2>1 使用IOC完成三层结构的解耦合</h2>
<h3>1.1 搭建三层结构</h3>
<p>建立Dao层接口:</p>
<pre>1 package org.guangsoft.dao;
2 /***
3  * 定义dao接口
4  * ***/
5 public interface UsersDao
6 {
7     public void saveUsers();
8 }</pre>
<p>Dao层接口的实现类</p>
<pre> 1 package org.guangsoft.dao.impl;
 2 import org.guangsoft.dao.UsersDao;
 3 //dao实现类
 4 public class UsersDaoImpl implements UsersDao
 5 {
 6     @Override
 7     public void saveUsers()
 8     {
 9         System.out.println("---------将对象保存到数据库--------");
10     }
11 }</pre>
<p>建立service接口</p>
<pre>1 package org.guangsoft.service;
2 /***
3  * 用户业务接口
4  * **/
5 public interface UsersService
6 {
7     public void addUsers();
8 }&nbsp;</pre>
<p>业务层接口的实现类</p>
<pre> 1 package org.guangsoft.service.impl;
 2 import org.guangsoft.dao.UsersDao;
 3 import org.guangsoft.service.UsersService;
 4 /***
 5  * 用户业务接口实现类
 6  * ***/
 7 public class UsersServiceImpl implements UsersService
 8 {
 9     // 以前：创建Dao对象
10     private UsersDao usersDao;
11     @Override
12     public void addUsers()
13     {
14         System.out.println("-----------调用Dao层的方法--------------");
15         usersDao.saveUsers();
16     }
17 }&nbsp;</pre>
<p>建立Action</p>
<pre> 1 package org.guangsoft.service.impl;
 2 import org.guangsoft.dao.UsersDao;
 3 import org.guangsoft.service.UsersService;
 4 /***
 5  * 用户业务接口实现类
 6  * ***/
 7 public class UsersServiceImpl implements UsersService
 8 {
 9     // 以前：创建Dao对象
10     private UsersDao usersDao;
11     @Override
12     public void addUsers()
13     {
14         System.out.println("-----------调用Dao层的方法--------------");
15         usersDao.saveUsers();
16     }
17 }&nbsp;</pre>

<h3>1.2使用spring管理三层的依赖</h3>

<pre> 1 &lt;?xml version="1.0" encoding="UTF-8"?&gt;
 2 &lt;!-- 到入xml文件的约束 --&gt;
 3 &lt;beans xmlns="http://www.springframework.org/schema/beans"
 4     xmlns:p="http://www.springframework.org/schema/p" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 5     xsi:schemaLocation="http://www.springframework.org/schema/beans
 6      http://www.springframework.org/schema/beans/spring-beans-4.1.xsd"&gt;
 7     &lt;!-- 1 实例化Dao对象 id:完成对象的引用 class:指定需要创建的对象对应的类的完全限定名 --&gt;
 8     &lt;bean id="usersDao" class="org.guangsoft.dao.impl.UsersDaoImpl"&gt;
 9     &lt;/bean&gt;
10     &lt;!-- 2实例化service --&gt;
11     &lt;bean id="usersService" class="org.guangsoft.service.impl.UsersServiceImpl"&gt;
12         &lt;!-- property：完成对象属性的注入（赋值） value:如果是简单的类型使用value（String,基本类型对应的包装类型） ref:完成对应的引用 --&gt;
13         &lt;property name="usersDao" ref="usersDao"&gt;&lt;/property&gt;
14     &lt;/bean&gt;
15     &lt;!-- 3实例化Action对象 --&gt;
16     &lt;bean id="usersAction" class="org.guangsoft.action.UsersAction"&gt;
17         &lt;property name="usersService" ref="usersService"&gt;&lt;/property&gt;
18     &lt;/bean&gt;
19 &lt;/beans&gt;</pre>

<h3>1.3三层结构的测试</h3>

<pre> 1 package org.guangsoft.test;
 2 import org.junit.Test;
 3 import org.springframework.context.ApplicationContext;
 4 import org.springframework.context.support.ClassPathXmlApplicationContext;
 5 import org.guangsoft.action.UsersAction;
 6 public class TestSpring
 7 {
 8     @Test
 9     public void testHelloSpring()
10     {
11         // 加载spring的配置文件，获得spring的bean容器
12         ApplicationContext ac
13         = new ClassPathXmlApplicationContext("applicationContext.xml");
14         // 从bean容器中获得需要的对象
15         UsersAction usersAction = (UsersAction) ac.getBean("usersAction");
16         // 调用action的方法
17         usersAction.userReg();
18     }
19 }&nbsp;</pre>
<p>理解spring的IOC 或者 DI:完成对象依赖的解耦合</p>
<h2>2 不同类型属性的注入</h2>
<h3>2.1简单类型属性</h3>

<pre> 1 &lt;!-- 实例化Pet类的对象 --&gt;
 2 &lt;bean id="pet" class="org.guangsoft.test.Pet"&gt;
 3     &lt;!-- 给属性赋值 简单类型的属性使用property标签的value属性赋值 javabean对象使用property标签的ref属性赋值
 4         调用set方法赋值 1 必须生成属性对应的set方法 2 set注入 --&gt;
 5     &lt;property name="pid" value="100100"&gt;&lt;/property&gt;
 6     &lt;property name="pnames" value="旺财"&gt;&lt;/property&gt;
 7 &lt;/bean&gt;
 8 &lt;!-- 使用构造注入 --&gt;
 9 &lt;bean id="pet2" class="org.guangsoft.test.Pet"&gt;
10     &lt;!-- 使用构造方法给属性赋值 1 根据constructor-arg标签的个数，找对应的构造方法 2 默认constructor-arg的顺序和构造方法的参数顺序是一致的
11         3 简单类型使用value，如果参数对象使用ref --&gt;
12     &lt;constructor-arg value="小强"&gt;&lt;/constructor-arg&gt;
13     &lt;constructor-arg value="120120"&gt;&lt;/constructor-arg&gt;
14 &lt;/bean&gt;
15  </pre>

<h3>2.2javabean类型</h3>
<p>Set或者构造注入：注入的时候使用ref注入</p>
<h3>2.3集合类型属性</h3>

<pre> 1 &lt;!-- 实例化Pet对象，给集合属性注入值 --&gt;
 2 &lt;bean id="pet3" class="org.guangsoft.test.Pet"&gt;
 3     &lt;!-- 给List属性赋值 --&gt;
 4     &lt;property name="lst"&gt;
 5         &lt;!-- list标签产生List对象 --&gt;
 6         &lt;list&gt;
 7             &lt;value&gt;list第一个元素&lt;/value&gt;
 8             &lt;ref bean="pt" /&gt; &lt;!-- list中的第二个元素 --&gt;
 9         &lt;/list&gt;
10     &lt;/property&gt;
11     &lt;!-- 给set属性注入值 --&gt;
12     &lt;property name="st"&gt;
13         &lt;set&gt;
14             &lt;value&gt;set第一个元素&lt;/value&gt;
15             &lt;bean class="org.guangsoft.test.Pet"&gt;&lt;/bean&gt;&lt;!-- 创建匿名对象，作为set的元素 --&gt;
16         &lt;/set&gt;
17     &lt;/property&gt;
18     &lt;!-- Map集合属性注入 --&gt;
19     &lt;property name="mp"&gt;
20         &lt;map&gt;
21             &lt;entry&gt;
22                 &lt;key&gt;
23                     &lt;value&gt;k1&lt;/value&gt;
24                 &lt;/key&gt;
25                 &lt;value&gt;v1&lt;/value&gt;
26             &lt;/entry&gt;&lt;!-- map集合中第一个元素 --&gt;
27             &lt;entry&gt;
28                 &lt;key&gt;
29                     &lt;value&gt;k2&lt;/value&gt;
30                 &lt;/key&gt;
31                 &lt;!-- 创建匿名对象，作为set的元素 --&gt;
32                 &lt;bean class="org.guangsoft.test.Pet"&gt;&lt;/bean&gt;
33             &lt;/entry&gt;&lt;!-- map集合中第二个元素 --&gt;
34         &lt;/map&gt;
35     &lt;/property&gt;
36     &lt;!-- Properties集合属性注入（重点） Properties:处理.properties文件，该文件中的键值对象都是字符串 --&gt;
37     &lt;property name="pps"&gt;
38         &lt;props&gt;
39             &lt;prop key="k1"&gt;v1&lt;/prop&gt;
40             &lt;prop key="k2"&gt;v2&lt;/prop&gt;
41         &lt;/props&gt;
42     &lt;/property&gt;
43 &lt;/bean&gt;&nbsp;</pre>

<h2>3 注入方式的总结</h2>
<p>Set注入：调用属性对应的set方法</p>
<p>　　　　简单类型的属性使用property标签的value属性赋值</p>
<p>javabean对象使用property标签的ref属性赋值</p>
<p>调用set方法赋值</p>
<p>1&nbsp;&nbsp; 必须生成属性对应的set方法</p>
<p>2 set注入</p>
<p>构造注入：调用构造方法给属性赋值</p>
<p>使用构造方法给属性赋值</p>
<p>1 根据constructor-arg标签的个数，找对应的构造方法</p>
<p>2 默认constructor-arg的顺序和构造方法的参数顺序是一致的</p>
<p>3 简单类型使用value，如果参数对象使用ref</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-21 06:40:50 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/odi/" title="odi">odi</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8d%e5%90%8c/" title="不同">不同</a>, <a href="https://www.biecuoliao.com/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.biecuoliao.com/tag/new/" title="new">new</a>, <a href="https://www.biecuoliao.com/tag/%e7%b3%bb%e7%bb%9f/" title="系统">系统</a>, <a href="https://www.biecuoliao.com/tag/%e7%ae%80%e5%8d%95/" title="简单">简单</a>, <a href="https://www.biecuoliao.com/tag/utf-8/" title="utf-8">utf-8</a>, <a href="https://www.biecuoliao.com/tag/sans/" title="sans">sans</a>, <a href="https://www.biecuoliao.com/tag/%e6%8e%a5%e6%94%b6/" title="接收">接收</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Spring控制反转与依赖注入(IOC、DI)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Yq9pq0.html" rel="bookmark">Spring控制反转和依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(1)为什么使用控制反转和依赖注入 调用者不用去关心被调用者的实现,不需要调用者亲自创建被调用者的实例,这些操作都交给框架去完成. 这种设计思想就是控制反转(Inversion of Control, IoC),同时,它还有另外一个名字就是依赖注入(Dependency Injection, DI). (2)什么是控制反转和依赖注入 控制反转(IoC)是将由程序控制的&quot;对象间的依赖关系&quot;转交给IoC容器来进行控制,被调用者的实例创建工作不再由调用者来完 成.通过控制反转,可以实现由外部			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZOVmZ4.html" rel="bookmark">对spring控制反转以及依赖注入的理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.说到依赖注入(控制反转),先要理解什么是依赖. Spring 把相互协作的关系称为依赖关系.假如 A 组件调用了 B 组件的方法,我们可称A 组件依赖于 B 组件. 二.什么是依赖注入. 在传统的程序设计过程中,通常由调用者来创建被调用者的实例. 在依赖注入的模式下,创建被调用者的工作不再由调用者来完成,因此称为控制反转:创建被调用者实例的工作通常由Spring 容器来完成,然后注入给调用者,因此也称为依赖注入. 自己理解:即一句话,由spring容器来控制组件A的调用的具体对象B.组件A依			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xAQAB3.html" rel="bookmark">IOC&sol;DI控制反转与依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				IOC/DI控制反转与依赖注入 IOC和DI表现的效果的是一样的只不过对于作用的对象不同,有了不一样的名字. 先用一个现实的例子来说明IOC/DI表现出来的效果. 上图,小冬的有一个吃的功能,营养师要求小冬要吃土豆,这个过程有很大的局限,也就是对于营养师来说,这个营养师只能要求小冬,并且还只能吃土豆,显然一个营养师只能给一个人去搭配营养,并且还然人家只能吃土豆,这样显然不可以!所以对此做个改进: 这一次营养师可以要求任何用能力吃的人,只要有能力吃,也就是实现吃的这一个能力人,就可以被营养师来要求			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qEPeD3.html" rel="bookmark">Spring框架之控制反转和依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				学Spring框架必须理解控制反转和依赖注入.下面各自举一个例子,来说明. IOC(控制反转):应用本身创建和维护的依赖对象:现在交由外部容器(Spring)来创建和维护:这个控制权的转移: 就叫做控制反转. 第一步:配置applicationContextcreateproject.xml和applicationcontext.xml(总体) &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;beans xmlns=			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JjEm94.html" rel="bookmark">轻松了解Spring中的控制反转和依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们回顾一下计算机的发展史,从最初第一台计算机的占地面积达170平方米,重达30吨,到现如今的个人笔记本,事物更加轻量功能却更加丰富,这是事物发展过程中的一个趋势,在技术领域中同样也是如此,企业级JavaBean(Enterprise JavaBean ,EJB)在创建之初是非常成功,但是时间一久人们便开始追逐更加方便更加简易和轻量级的技术框架实现,于是Spring就应运而生,并且Sring一直开始不断地涉及到其他领域(这里就不再多详谈了),而Spring的精髓当中就包括控制反转和依赖注入. 浅			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RxQ654.html" rel="bookmark">轻松了解Spring中的控制反转和依赖注入（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				紧接上一篇文章&lt;轻松了解Spring中的控制反转和依赖注入&gt;讲解了SpringIOC和DI的基本概念,这篇文章我们模拟一下SpringIOC的工作机制,使我们更加深刻的理解其中的工作. 类之间的结构图如下 以下是代码 BeanFactor接口:在Spring源码中的定义是:持有对一定数量的Bean的定义,同时每个Bean都被唯一标识的对象(类),需要实现这个接口.根据对Bean的定义,该工厂将会返回一个包含Bean定义的对象的独立实例(原型设计模式),或者单例共享(一个不错的单例设计模式,)范			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kvjEpM.html" rel="bookmark">Spring理论基础-控制反转和依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				序第一次了解到控制反转(Inversion of Control)这个概念,是在学习Spring框架的时候.IOC和AOP作为Spring的两大特征,自然是要去好好学学的.而依赖注入(Dependency Injection,简称DI)却使得我困惑了挺久,一直想不明白他们之间的联系.控制反转控制反转顾名思义,就是要去反转控制权,那么到底是哪些控制被反转了?在2004年 Martin fowler 大神就提出了 &quot;哪些方面的控制被反转了?&quot; 这个问题,他总结出是依赖对象的获得被反转了.在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDlDk8M.html" rel="bookmark">spring的容器（控制反转、依赖注入）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.spring的容器 ”容器“是spring的一个重要概念,其主要作用是完成创建成员变量,并完成装配. 而容器的特点”控制反转“和”依赖注入“是两个相辅相成的概念. 控制反转:我们在使用一个类型的实例实现某个功能时,需要先new出该类型的一个实例,并赋值给我们声明的某个引用变量,这样我们才能够使用该变量进行操作.而new和赋值本事我们自己的权限,此处便是将该控制权限反转交给了spring. 依赖注入:某个类型要完成一个功能往往需要其他类型的变量来完成,我们在程序中往往通过自己new的方式来完成			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k9aDz4.html" rel="bookmark">spring学习总结一----控制反转与依赖注入</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring作为java EE中使用最为广泛的框架,它的设计体现了很多设计模式中经典的原则和思想,所以,该框架的各种实现方法非常值得我们去研究,下面先对spring中最为重要的思想之一----控制反转(依赖注入)进行简单的总结. 一.控制反转与依赖注入的概念 在学习spring框架的时候,我们习惯性地将控制反转和依赖注入放在一起,其实,两者体现的思想原则都是差不多的,只不过控制反转是一种更广泛的程序操作理念,而依赖注入是一种更为具体的实现方法,总的来说,控制反转可以依靠依赖注入来实现. 1.控制			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47NkXY3.html" rel="bookmark" class="title">扩展性</a>
					<div>
						服务的扩展性 在编写一个应用时,我们常常考虑的是该应用应该如何实现特定的业务逻辑.但是在逐渐发展出越来越多的用户后,这些应用常常会暴露出一系列问题,如不容易增大容量,容错性差等等.这常常会导致这些应用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkX99M.html" rel="bookmark" class="title">解决办法&colon;CMake编译时出现&OpenCurlyDoubleQuote;error in configuration process project files may be invalid&rdquo;</a>
					<div>
						无论是CMake2.84 还是当前最新的CMake2.87都可能会出现这种错: 查遍国内外的网上都没有给出可行办法,结果还是自己解决了 现把出错原因和解决办法如下:出错原因:因是英文版本,通常安装没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AmQVd4.html" rel="bookmark" class="title">silverlight wcf  mvvm</a>
					<div>
						最近工作比较忙,也没有时间发表新内容,今天有点时间,就顺便写点,说说最近开发的一套系统心得. 我刚去这个公司已经将前端确定要用Silverlight,我不知道为什么要选择这个,也许是为以后转C/S系统 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGP1BY0.html" rel="bookmark" class="title">limit 百万级数据分页优化方法</a>
					<div>
						mysql教程 这个数据库教程绝对是适合dba级的高手去玩的,一般做一点1万 篇新闻的小型系统怎么写都可以,用xx框架可以实现快速开发.可是数据量到了10万,百万至千万,他的性能还能那么高吗? 一点小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e5e6b0.html" rel="bookmark" class="title">SAE上安装第三方模块</a>
					<div>
						当sae上没有自己所需要的第三方模块时,可以使用saecloud install package [package...]将所需要的模块安装到本地应用文件夹下,然后在index.wsgi下添加如何代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xrraQ4.html" rel="bookmark" class="title">centos 安装 mysql5&period;6</a>
					<div>
						先到官网下载 http://www.mysql.com/downloads/ 我是放在/root/download下面的 先解压 unzip V47187-01.zip  tar zxvf mysql ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Moxkkl0.html" rel="bookmark" class="title">添加墙元素实现碰撞效果</a>
					<div>
						碰撞效果实现: 利用CollisionUtils判断两个对象是否发生碰撞 x1:第一个矩形的x坐标 y1:第一个矩形的y坐标 w1:第一个矩形的宽度 h1:第一个矩形的高度 x2:第二个矩形的x坐标  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWrOY3.html" rel="bookmark" class="title">Yii2&period;0 初识 RESTful Serializer</a>
					<div>
						当RESTful API响应中包含一个资源时,该资源需要序列化成一个字符串. Yii将这个过程分成两步,首先,资源会被yii\rest\Serializer转换成数组, 然后,该数组会通过yii\we ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPZ88n3.html" rel="bookmark" class="title">Hibernate复习&lpar;二&rpar;主要对象</a>
					<div>
						1.SessionFactory 一个SessionFactory实例对应一个数据存储源,应用从SessionFactory中获得Session实例. SessionFactory有以下特点: –它是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38bkZyM.html" rel="bookmark" class="title">middleware中间件</a>
					<div>
						django 中的中间件(middleware),在django中,中间件其实就是一个类,在请求到来和结束后,django会根据自己的规则在合适的时机执行中间件中相应的方法. 在django项目的se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/022dYp0.html" rel="bookmark" class="title">Spring MVC 基本配制</a>
					<div>
						WEB.XML 文件中的配制: &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;web-app id=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRXZQ4.html" rel="bookmark" class="title">hq-常用帐号跟服务器地址</a>
					<div>
						邮箱 zh:zhangshuli mm:Hq999000! RTX zh:zhangshuli mm:125116_ssdd 域名/win7 zh:zhangshuli mm:125116_ssdd  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8o67M.html" rel="bookmark" class="title">Nmap命令的29个实用范例</a>
					<div>
						Nmap即网络映射器对Linux系统/网络管理员来说是一个开源且非常通用的工具.Nmap用于在远程机器上探测网络,执行安全扫描,网络审计和搜寻开放端口.它会扫描远程在线主机,该主机的操作系统,包过滤器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zqm180.html" rel="bookmark" class="title">hihocoder &num;1468 &colon; 2-SAT&amp;&num;183&semi;hihoCoder新春晚会  2-SAT</a>
					<div>
						题目链接: http://hihocoder.com/problemset/problem/1468 题意: hihoCoder新春晚会正在紧张地筹备中.晚会分为上半场和下半场,总导演小Hi现在要为N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmmavM.html" rel="bookmark" class="title">CDOJ 30 最短路 解题报告</a>
					<div>
						啊啊啊打博文真是累的要死…… 题目链接:http://acm.uestc.edu.cn/#/problem/show/30 题目就是标算,不解释了,用的是Bellman Ford算法,的队列优化版SP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvRLzM.html" rel="bookmark" class="title">volley&lpar;2&rpar; 参数code &colon; or&lowbar;barcode&comma; pr&lowbar;ismsd&colon;false &comma; method&colon;GET</a>
					<div>
						/** * 当编辑框里面的内容完成的时候,自动的,同时获取服务器的批量数 */private void barcodeEnterEvent(String outboxcode) { mRequestQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6XmD0.html" rel="bookmark" class="title">The Letter Carrier&amp;&num;39&semi;s Rounds（摘）</a>
					<div>
						Description For an electronic mail application you are to describe the SMTP-based communication that ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEjNDy0.html" rel="bookmark" class="title">java 线程 wait  join sleep yield notify notifyall synchronized</a>
					<div>
						韩梦飞沙  韩亚飞  [email protected]  yue31313  han_meng_fei_sha 休息方法 : 在指定时间内 让该线程 暂停, 不会释放 锁标志. 等待方法: 让 该  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KjbnKM.html" rel="bookmark" class="title">jpa hibernate mybatis</a>
					<div>
						jpa: entityManagerFactory: org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean hibern ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPegvM.html" rel="bookmark" class="title">二：Unit 4</a>
					<div>
						###################################### ###########II 第四单元################ ########################## ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
